<?php

/*

  This is a wrapper script to run Nanoweb below Apache (in http
  user space, commonly known as CGI).

  - it is recommended to use a "big" nanoweb binary, with the configuration
    and modules already inside (use the "mkhugenanoweb.php" utility)
  - the PHP binary is only required when invoking nanoweb.php via the slower
    (but more stable) exec() syscall, when FAST_INLINE_NANOWEB is set to 0

  #-- For apache activate this wrapper in .htaccess as follows:
    RewriteEngine On
    RewriteRule .* /nanoweb/cgi-nanoweb-wrapper.php [L]

  #-- a good alternative (if your evil provider disabled Apache's mod_rewrite)
    ErrorDocument 403 /nanoweb/cgi-nanoweb-wrapper.php

*/


$NANOWEB_BINARY = "/usr/sbin/nanoweb.php";	# "/var/www/nanoweb/large-nanoweb.php";
$FAST_INLINE_NANOWEB = 1;
$PHP_BINARY = "/usr/local/bin/php";		# "/var/www/nanoweb/php-cgi";

$TEMP_DIR="/tmp";



#-- init
error_reporting(0);

#-- save http environment
$server_docroot = $_SERVER["DOCUMENT_ROOT"];
$server_hostname = $_SERVER["SERVER_NAME"];
$server_addr = $_SERVER["SERVER_ADDR"];
$server_admin = $_SERVER["SERVER_ADMIN"];
$request_method = $_SERVER["REQUEST_METHOD"];
($request_string = $_SERVER["REDIRECT_REQUEST_URI"]) or
($request_string = $_SERVER["REQUEST_URI"]);
$request_protocol = $_SERVER["SERVER_PROTOCOL"];
$request_body = $_SERVER["CONTENT_LENGTH"];
if ($_ENV["CGI_NANOWEB_WRAPPER"]) { ex("HTTP/1.1 500 Subserver loop detected"); } else { putenv("CGI_NANOWEB_WRAPPER=1"); }

#-- reconstructing HTTP request
$request_head = $request_method." ".$request_string." ".$request_protocol."\n";
if (function_exists("getallheaders")) {
	foreach (getallheaders() as $name=>$value) {
		$request_head .= $name.": ".$value."\n";
	}
}
else {
	if (empty($_SERVER["HTTP_HOST"])) {
		 $request_head .= "Host: ".$server_hostname."\n";
	}
	foreach ($_SERVER as $id=>$value) {
		if ((strpos($id,"HTTP_") === 0) && (strpos($value,"\n")===false)) {
			$name = substr($id, 5);
			$name = str_replace("_", " ", $name);
			$name = strtolower($name);
			$name = ucwords($name);
			$name = str_replace(" ", "-", $name);
			$request_head .= $name.": ".$value."\n";
		}
	}
	if (!empty($request_body)) {
		$request_head .= "Content-Length: ".$_SERVER["CONTENT_LENGTH"]."\n";
		$request_head .= "Content-Type: ".$_SERVER["CONTENT_TYPE"]."\n";
	}
}
$request_head .= "\n";

#-- add POST/PUT requests` body
if (! empty($request_body)) {
	if (!empty($request_body_data)) {
	}
	elseif (isset($_SERVER["HTTP_RAW_POST_DATA"])) {
		$request_body_data = $_SERVER["HTTP_RAW_POST_DATA"];
	}
	elseif ($fp = fopen("php://input", "r")) {
		$request_body_data = fread($fp, 0x0100000);
		fclose($fp);
	}
	else {
		ex("HTTP/1.1 500 Request Body Unaccessible");
	}
}


#-- setup nanoweb.php inetd environment
putenv("INETD_REMOTE_IP=".$_SERVER["REMOTE_ADDR"]);
putenv("INETD_REMOTE_PORT=".$_SERVER["REMOTE_PORT"]);
foreach ($_SERVER as $var=>$uu) {
	putenv($var);
}

#-- prepare nanoweb.php cmdline args:
$_SERVER["argv"] = array(
	$NANOWEB_BINARY,
	"--quiet",
	"--set-option=SERVERMODE=inetd",
	"--set-option=SINGLEPROCESSMODE=1",
	"--set-option=MAXSERVERS=1",
	"--set-option=LOGGERPROCESS=0",
	"--set-option=KEEPALIVE=",
	"--set-option=LOGTOCONSOLE=0",
	"--set-option=PIDFILE=",
	"--set-option='SERVERNAME=$server_hostname'",
	"--set-option='DOCUMENTROOT=$server_docroot'",
	"--set-option='SERVERADMIN=$server_admin'",
	"--set-option='LISTENINTERFACE=$server_addr'",
   //	"--add-option='ADDHEADER=X-Subserver-Wrapper: cgi-nanoweb/2.0.1-dev'",
   //	"--set-option=ACCESSFILE=.nwaccess",
);
$_SERVER["argc"] = count($_SERVER["argv"]);

#-- "start" nanoweb.php
if ($FAST_INLINE_NANOWEB) {

	// ex("HTTP/1.1 500 NOT YET IMPLEMENTED");

	#-- define dummy socket ext functions 
	if (!function_exists("socket_create")) {
		function socket_create($d,$t,$p) { return(false); }
		function socket_shutdown($s,$h=0) { return(false); }
		function socket_close($s) { return(false); }
	}

	#-- read nanoweb.php binary
	if ($fp = fopen($NANOWEB_BINARY, "r")) {
		$nwbin = fread($fp, 0x0100000);
		fclose($fp);
	}
	if (empty($nwbin)) {
		ex("HTTP/1.1 500 Subserver binary couldn't be read");
	}

	#-- patches:
	$REPLACEMENTS = array(
		# - - - - - - - -
		'$buf=read_request('
		=> '$buf=$request_head;
			$dp=strpos($buf,"\n\n");
			$pn=2;
			#<off># $buf=read_request(',
		# - - - - - - - -
		'$buf.=read_request('
		=> '$bug.=$request_body_data;   #<off># $buf.=read_request(',
		# - - - - - - - -
		'$hbuf=build_response_headers()'
		=> '$hbuf="";
							foreach (explode("\n",build_response_headers()) as $hline) {
								if (strpos($hline,"Server:")===0) { $hline = "X-".$hline; }
								header($hline);
							}
							#<off># $hbuf=build_response_headers()'
		# - - - - - - - -
	);
	#-- apply
	foreach ($REPLACEMENTS as $orig => $new) {
		$nwbin = str_replace($orig, $new, $nwbin);
	}
	#-- strip first two lines, and the '?''>' at the bottom:
	list($uu, $uu, $nwbin) = explode("\n", $nwbin, 3);
	$nwbin = substr($nwbin, 0, strlen($nwbin) - 2);

	#-- remove ' from $argv
	foreach ($_SERVER["argv"] as $i=>$v) {
		$_SERVER["argv"][$i] = str_replace("'", "", $v);
	}

	#-- "execute" patched nanoweb.php
	eval($nwbin);

}
else {

	if ($fp=fopen($tmp_request_file=$TEMP_DIR.DIRECTORY_SEPARATOR."cgi-nanoweb-wrapper-http-request.".base_convert(time(),10,36).".".getmypid(), "w")) {
		fwrite($fp, $request_head.$request_body_data);
		fclose($fp);
	}
	else {
		ex("HTTP/1.1 500 Subserver unavailable");
	}

	$pipe = popen(
	$s=	$PHP_BINARY .
//		" -c /var/www/nanoweb/my-php.ini " .
		" -f " .
		implode(" ", $_SERVER["argv"]) .
		" " .
		" < $tmp_request_file",			"r"
	);

	if ($pipe) {
		if (PHP_SAPI != "CLI") {
			while (!feof($pipe) && ($line=trim(fgets($pipe)))) {
				if (strpos($line, "Server: ")===0) { $line = "X-".$line; }
				header($line);
				if (empty($line)) break;
			}
		}
		while (!feof($pipe)) {
			echo(fread($pipe, 1024));
		}
		pclose($pipe);
	}

	unlink($tmp_request_file);

}


function ex($msg) {
	@header($msg);
	die($msg);
}

?>